%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Removed_Offsets_Counter = Remove_BarFast_Offsets(Fastener_Index)

global ErrCode;

global DB_FASTENERS;

% Инициализация счетчиков
Removed_Offsets_Counter = 0;

% Цикл по ярусам
for j=1:DB_FASTENERS{Fastener_Index}.N_layers

    % Если есть MPC для офсета
    if (~isempty(DB_FASTENERS{Fastener_Index}.Offset_MPCs{j}))

        % Удаление MPC
        MPC_list = DB_FASTENERS{Fastener_Index}.Offset_MPCs{j};

        Append_To_Output(PCL_MPC_Delete(MPC_list));
        DB_MPC_Delete(MPC_list);

        if (ErrCode < 0)
            return;
        end

        % Соединение стержня болта с текущим ярусом сетки
        Node_To_Remove = DB_FASTENERS{Fastener_Index}.Shank_nodes(j);

        switch j
            case (1)
                Element_list = DB_FASTENERS{Fastener_Index}.Shank_elements(1);
            case DB_FASTENERS{Fastener_Index}.N_layers
                Element_list = DB_FASTENERS{Fastener_Index}.Shank_elements(DB_FASTENERS{Fastener_Index}.N_layers - 1);
            otherwise
                Element_list = [DB_FASTENERS{Fastener_Index}.Shank_elements(j-1); DB_FASTENERS{Fastener_Index}.Shank_elements(j)];
        end

        Node_list = DB_FASTENERS{Fastener_Index}.Shank_nodes(j);
        Target_Node_list = DB_FASTENERS{Fastener_Index}.Joint_nodes(j);

        Append_To_Output(PCL_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list));
        DB_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list);

        if (ErrCode < 0)
            return;
        end

        % Удаление узла
        Node_list = Node_To_Remove;

        Append_To_Output(PCL_Node_Delete(Node_list));
        DB_Node_Delete(Node_list);

        if (ErrCode < 0)
            return;
        end

        % Внесение изменений в базу данных крепежа
        DB_FASTENERS{Fastener_Index}.Offset_MPCs{j} = [];
        DB_FASTENERS{Fastener_Index}.Shank_nodes(j) = DB_FASTENERS{Fastener_Index}.Joint_nodes(j);

        % Обновление счетчика
        Removed_Offsets_Counter = Removed_Offsets_Counter + 1;

    end

end
